import java.util.Random;

public class TestFixed {

  public int count;

  public void TestFixed() {
    count = 0;
  }

  public synchronized void increment() {
    count++;
    System.out.println("Thread: writing " + count);
  }

  public static void main(String[] args) {
    final TestFixed t = new TestFixed();
    Thread[] threads = new Thread[10];
    for (int i = 0; i < 10; i++) {
      threads[i] =
        new Thread(
          new Runnable() {
            private Random r;
            public void run() {
              r = new Random();
              for (int j = 0; j < 3; j++) {
                t.increment();
              }
            }
          }
        );
    }
    for (Thread th : threads) {
      th.start();
    }
    for (Thread th : threads) {
      try {
        th.join();
      } catch (Exception ex) {
      }
    }
    System.out.println("t.count = " + t.count);
  }
}
